//200211 fujigaya2

#define SPECTRUM_NUM_A 50
#define SPECTRUM_NUM_B 50
#define EXT_INT_PIN_NUM  2

volatile int period_counter_a[SPECTRUM_NUM_A];
volatile int period_counter_b[SPECTRUM_NUM_B];
volatile unsigned long past_us;
volatile bool first_flag;
//Task Schedule
unsigned long gPreviousL5 = 0;
#define CYCLE_MS_SERIAL 500


void setup()
{
  // put your setup code here, to run once:
  //set input DCC signal 
  pinMode( EXT_INT_PIN_NUM, INPUT );
  first_flag = true;
  past_us = micros();//resolution:4us 
  gPreviousL5 = millis();
  attachInterrupt(digitalPinToInterrupt(EXT_INT_PIN_NUM), count_us_period, RISING);
  Serial.begin(115200);
}

void loop()
{
  // put your main code here, to run repeatedly:
  if((millis() - gPreviousL5) > CYCLE_MS_SERIAL)
  {
    noInterrupts();
      Serial.println(output_string());
      counter_clear();
      first_flag = true;
      gPreviousL5 = millis();
    interrupts();
  }
}

String output_string()
{
  String temp_s = "  A(0.1ms),";
  for(int i = 0 ;i < SPECTRUM_NUM_A; i ++)
  {
    temp_s += String(period_counter_a[i]) + ",";
    if((i%10) == 9)
    {
      temp_s += "(" + String((i+1)/10) + "),";
    }
  }
  
  temp_s += "  B(10ms),";
  for(int i = 0 ;i < SPECTRUM_NUM_B; i ++)
  {
    temp_s += String(period_counter_b[i]) + ",";
    if((i%10) == 9)
    {
      temp_s += "(" + String((i+1)*10) + "),";
    }
  }
  return temp_s;
}

void counter_clear()
{
  //counter clear
  for(int i = 0;i < SPECTRUM_NUM_A;i++)
  {
    period_counter_a[i] = 0;
  }
  for(int i = 0;i < SPECTRUM_NUM_B;i++)
  {
    period_counter_b[i] = 0;
  }
}

void period_classify(unsigned long period_us)
{
  unsigned long period_class = period_us / 100;
  if(period_class < SPECTRUM_NUM_A)
  {
    period_counter_a[period_class] ++;
  }
  else
  {
    period_counter_a[SPECTRUM_NUM_A - 1] ++;
  }

  period_class = period_us / 10000;
  if(period_class < SPECTRUM_NUM_B)
  {
    period_counter_b[period_class] ++;
  }
  else
  {
    period_counter_b[SPECTRUM_NUM_B - 1] ++;
  }
  
}

void count_us_period()
{
  //count duty
  unsigned int period_us = micros() - past_us;
  past_us = micros();
  if(first_flag == true)
  {
    //一個目はカウントしない
    first_flag = false;
    return;    
  }
  period_classify(period_us);
}
